unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Button1: TButton;
    OpenDialog1: TOpenDialog;
    Label4: TLabel;
    Edit4: TEdit;
    Edit5: TEdit;
    Label5: TLabel;
    Label6: TLabel;
    Edit6: TEdit;
    Edit7: TEdit;
    Label7: TLabel;
    Edit8: TEdit;
    Label8: TLabel;
    Button4: TButton;
    ListBox1: TListBox;
    Button2: TButton;
    Button3: TButton;
    Memo1: TMemo;
    CheckBox1: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses idantifreeze, idftp, IdAntiFreezeBase, IdTCPClient;

{$R *.dfm}

type
  TUploaderThread=class(TThread)
  private
    FFileName:string;
    FServer:string;
    FPort:integer;
    FPassive:boolean;
    FUser,
    FPassword,
    FDestinationDir:string;
    FE:Exception;
    procedure HandleException;
    procedure FinishedUpload;
  protected
    procedure execute; override;
  public
    constructor Create(AServer:string; APort:integer; APassive:boolean; AUser, APassword, ADestinationDir, AFileName:string);
  end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if opendialog1.Execute then
    listbox1.items.add(opendialog1.filename);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if listbox1.ItemIndex=-1 then
     exit;
  listbox1.DeleteSelected;
end;

procedure TForm1.Button4Click(Sender: TObject);
var i:integer;
begin
  if listbox1.items.count=0 then
  begin
    showmessage('You must add at least one file to the list.');
    exit;
  end;
  memo1.Clear;
  with TIdFtp.Create(self) do
  try
    Username:=edit6.text;
    Password:=edit7.text;
    Passive:=checkbox1.checked;
    Connect(edit4.text, strtointdef(edit5.text, 21));
    if edit8.text<>'' then
      ChangeDir(edit8.text);
    for i:=1 to listbox1.items.count do
    begin
      memo1.lines.add('starting upload: '+listbox1.Items[i-1]);
      try
        Put(listbox1.Items[i-1]);
        memo1.lines.add('finished upload: '+listbox1.Items[i-1]);
      except
        on e:exception do
          memo1.lines.add('error uploading '+listbox1.Items[i-1]+': '+e.message);
      end;
    end;
  finally
    free;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  with TIdAntiFreeze.Create(self) do
    Active:=true;
end;

procedure TForm1.Button3Click(Sender: TObject);
var i:integer;
begin
  if listbox1.items.count=0 then
  begin
    showmessage('You must add at least one file to the list.');
    exit;
  end;
  showmessage('Note that this method can fail on some files if your ftp server is configured ot only allow a specific number of concurrent connections.');
  memo1.Clear;
  for i:=1 to listbox1.items.count do
  begin
    memo1.lines.add('starting upload: '+listbox1.Items[i-1]);
    TUploaderThread.Create(edit4.text, strtointdef(edit5.text, 21), checkbox1.checked, edit6.text, edit7.Text, edit8.Text, listbox1.items[i-1]);
  end;
end;

{ TUploaderThread }

constructor TUploaderThread.Create(AServer:string; APort:integer; APassive:boolean; AUser, APassword, ADestinationDir, AFileName: string);
begin
  FServer:=AServer;
  FPort:=APort;
  FPassive:=APassive;
  FUser:=AUser;
  FPassword:=APassword;
  FDestinationDir:=ADestinationDir;
  FFileName:=AFileName;
  inherited create(false);
end;

procedure TUploaderThread.execute;
begin
  try
    with TIdFtp.Create(nil) do
    try
      Username:=FUser;
      Password:=FPassword;
      Passive:=FPassive;
      Connect(FServer, FPort);
      if FDestinationDir<>'' then
        ChangeDir(FDestinationDir);
      Put(FFileName);
      Synchronize(FinishedUpload);
    finally
      free;
    end;
  except
    on e:exception do
      Synchronize(HandleException);
  end;
end;

procedure TUploaderThread.FinishedUpload;
begin
  form1.memo1.lines.add('finished uploading '+FFilename);// note that using global variable form1 is not recommended unless you know what you are doing
end;

procedure TUploaderThread.HandleException;
begin
  form1.memo1.lines.add('error uploading '+FFilename+': '+fe.message);// note that using global variable form1 is not recommended unless you know what you are doing
end;

end.
